//$(
//=======================================================================
//
//      File: $RCSfile: watchdog.h,v $
//      Version: $Revision: $  Dated: $Date: $
//
//=======================================================================
//
//
//  FILE: watchdog.h
//
//  DESCRIPTION:
//
//      Contains defines and prototypes for the watchdogRT program.
//
//
//$)
//

#include <stdio.h>
#include <unistd.h>
#include <pthread.h>
#include <sched.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <fcntl.h>
#include <time.h>
#include <linux/mc146818rtc.h>

#include <errors.h>

/* Defines */
#define THREAD_1	1

#define WATCHDOG_ALARM_ADVANCE_SECS	5
#define WATCHDOG_ALARM_INIT_SECS ( WATCHDOG_ALARM_ADVANCE_SECS + 2 )
#define WATCHDOG_ALARM_SLEEP_SECS ( WATCHDOG_ALARM_ADVANCE_SECS - 2 )



typedef struct startup_tag {
    pthread_mutex_t     mutex;  /* protects access to 'go' */
    pthread_cond_t      cond;   /* signals change in 'go' */
    int                 go;     /* access protected by mutex */
} startup_t;


/* Prototypes */
void *rtWatchdogThread( void *arg );
int rtWatchdogInit( void );
void rtWatchdogAdvance( int alarmSecs );

void  wait_for_go( int thread_number );

